<?php
/**
 * @package Slightly Ajax Posts Loader Engine
 * 
 * Copyright (C) 2018 CattleMute.
 *
 * Controller
 *
 */

class Saple {

	function __construct() {

		global $SapleAdmin, $SapleFrontal;

		$SapleAdmin = new SapleAdmin();
		$SapleFrontal = new SapleFrontal();

		add_action( 'admin_menu', array( $this, 'menu' ) );
		add_action( 'admin_init', array( $this, 'enqueue_script' ) );

	}

	public function menu() {

		add_menu_page( __( 'Ajax posts', 'saple' ), __( 'Ajax posts', 'saple' ), 'manage_options', 'saple', array( $this, 'dashboard' ), 'dashicons-plus-alt', 80 );
		add_submenu_page( 'saple', __( 'Posts load settings', 'saple' ), __( 'Posts load settings', 'saple' ), 'manage_options', 'saple_settings', array( $this, 'setting' ) );

	}

	public function enqueue_script() {

		if( is_admin() && isset( $_GET['page'] ) && false !== strpos( esc_html( $_GET['page'] ) ,'saple' ) )
			wp_enqueue_style( 'style-saple', plugins_url() . '/slightly-ajax-posts-loader-engine/css/style.css' );

	}

	public function dashboard() {

		require( dirname( __FILE__ ) . '/../views/template-dashboard.php' );

	}

	public function setting() {

		global $SapleAdmin;

		$_option      = $SapleAdmin->option();
		$_option_name = $SapleAdmin->get_option_name();

		$_output_mode_array = array( 'button' => 'Button', 'scroll' => 'Scroll' );;

		if ( isset( $_POST[$_option_name] ) ){

			$_data = array();

			foreach ( $_POST[$_option_name] as $_key => $_val ){
				$_data[$_key] = ! is_array( $_val ) ? stripslashes( $_val ) : $_val;
			}

			update_option( $_option_name, $_data );

			$_option = $SapleAdmin->option();

		}

		if( ! empty( $_POST ) )
			echo '<div id="setting-error-settings_updated" class="updated settings-error notice is-dismissible" style="margin-left:0;"><p><strong>' . __( 'Saved.', 'safse' ) . '</strong></p></div>';

		require( dirname(__FILE__) . '/../views/template-setting.php' );

	}

}

class SapleAdmin {

	const SAPLE_ADMIN_OPTION = 'saple_setting';

	public function get_option_name() {

		return self::SAPLE_ADMIN_OPTION;

	}

	public function option() {

		$_option = get_option( self::SAPLE_ADMIN_OPTION );

		$_option['parent_element'] = '' !== $_option && isset( $_option['parent_element'] ) ? $_option['parent_element'] : '';
		$_option['output_mode']    = '' !== $_option && isset( $_option['output_mode'] ) ? $_option['output_mode'] : 'button';
		$_option['more_string']    = '' !== $_option && isset( $_option['more_string'] ) ? $_option['more_string'] : '';
		$_option['loading_symbol']    = '' !== $_option && isset( $_option['loading_symbol'] ) ? $_option['loading_symbol'] : '';
		$_option['any']            = '' !== $_option && isset( $_option['any'] ) ? $_option['any'] : '';
		$_option['frontpage']      = '' !== $_option && isset( $_option['frontpage'] ) ? $_option['frontpage'] : '';
		$_option['category']       = '' !== $_option && isset( $_option['category'] ) ? $_option['category'] : '';
		$_option['tag']            = '' !== $_option && isset( $_option['tag'] ) ? $_option['tag'] : '';
		$_option['cpost']          = '' !== $_option && isset( $_option['cpost'] ) ? $_option['cpost'] : '';
		$_option['term']           = '' !== $_option && isset( $_option['term'] ) ? $_option['term'] : '';
		$_option['search']         = '' !== $_option && isset( $_option['search'] ) ? $_option['search'] : '';
		$_option['date']           = '' !== $_option && isset( $_option['date'] ) ? $_option['date'] : '';
		$_option['archive']        = '' !== $_option && isset( $_option['archive'] ) ? $_option['archive'] : '';

		for ( $i = 1; $i <= 10; $i++ ) {
			$_option['user' . $i]   = '' !== $_option && isset( $_option['user' . $i] ) ? $_option['user' . $i] : '';
		}

		return $_option;

	}

	public function set_input( $_option_name = 'option[]', $_option_value = '' ) {

		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_string( $_option_value ) ? $_option_value : '';

		$_string = '';

		$_string .= '<input type="text" name="' . $_option_name . '" value="' . esc_html( $_option_value ) . '" class="saple-admin-input-text" />';
		
		echo $_string;

	}

	public function set_textarea( $_option_name = 'option[]', $_option_value = '' ) {

		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_string( $_option_value ) ? $_option_value : '';

		$_string = '';

		$_string .= '<textarea name="' . $_option_name . '" class="saple-admin-textarea" />' . esc_html( $_option_value ) . '</textarea>';
		
		echo $_string;

	}

	public function set_select( $_select_array = false, $_option_name = 'option[]', $_option_value = '' ) {

		$_select_array = is_array( $_select_array ) ? $_select_array : array( 'select' => 'Select' );
		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_string( $_option_value ) ? $_option_value : '';

		$_string = '';

		$_string .= '<select name="' . $_option_name . '" class="saple-admin-select">';

		foreach ( $_select_array as $_key => $_val ) {
			$_string .= '<option value="' . esc_html( $_key ) . '"' . ( $_key === $_option_value ? ' selected="selected"' : '' ) . '>';
			$_string .= esc_html( __( $_val, 'saple' ) );
			$_string .= '</option>';
		}

		$_string .= '</select>';
		
		echo $_string;

	}

	public function set_checkbox( $_select_array = false, $_option_name = 'option[]', $_option_value = false) {

		$_select_array = is_array( $_select_array ) ? $_select_array : array( 0 => 'check' );
		$_option_name  = is_string( $_option_name ) ? $_option_name : 'option[]';
		$_option_value = is_array( $_option_value ) ? $_option_value : array( 0 => '' );

		$_string = '';

		foreach ( $_select_array as $_key => $_val ) {
			$_string .= '<label class="saple-admin-label">';
			$_string .= '<input type="checkbox" name="' . $_option_name . '[]' . '" value="' . esc_html( $_val ) . '"' . ( in_array( $_val, $_option_value ) ? ' checked="checked"' : '' ) . ' class="saple-admin-checkbox" />';
			$_string .= esc_html( __( $_val, 'saple' ) );
			$_string .= '</label>';
		}
		
		echo $_string;

	}

}

class SapleFrontal {

	function __construct() {

		add_action( 'wp_head', array( $this, 'enqueue_scripts' ) );
		add_action( 'wp_head', array( $this, 'load_scripts' ) );

		add_action( 'wp_ajax_saple_output', array( $this, 'output' ) );
		add_action( 'wp_ajax_nopriv_saple_output', array( $this, 'output' ) );

	}

	public function enqueue_scripts() {

		wp_enqueue_style( 'saple-style', plugins_url( 'slightly-ajax-posts-loader-engine' ) . '/css/saple.css' );
		wp_enqueue_script( 'saple-script', plugins_url( 'slightly-ajax-posts-loader-engine' ) . '/js/saple.js', array( 'jquery' ) );

	}

	public function load_scripts() {

		global $SapleAdmin;

		$_option = $SapleAdmin->option();

		$_scripts = '';

		$_query_args = null;
		$_query      = null;

		$_query_args = $this->specify();
		$_query      = $this->query( $_query_args );

		$_parent_element = '' !== $_option['parent_element'] ? $_option['parent_element'] : 'main' ;
		$_output_mode    = 'scroll' !== $_option['output_mode'] ? 'scrolling: false,' : 'scrolling: true,';
		$_more_string    = '' !== $_option['more_string'] ? 'button: \'' . esc_html( $_option['more_string'] ) . '\',' : '';
		$_loading_symbol = '' !== $_option['loading_symbol'] ? preg_replace( '~\r\n|\r|\n|\t~', '', 'symbol: \'' . $_option['loading_symbol'] . '\',' ) : '';

		$_ajax_url      = admin_url( 'admin-ajax.php' );
		$_ajax_query    = json_encode( $_query_args );
		$_ajax_paged    = 0 === get_query_var( 'paged', 0 ) ? 1 : get_query_var( 'paged', 1 );
		$_ajax_max      = $_query->max_num_pages;
		$_ajax_template = $this->template_type();

		$_scripts .= <<<EOT
var saple_ajax = {
	url:'{$_ajax_url}',
	query:'{$_ajax_query}',
	paged:'{$_ajax_paged}',
	maxpages:'{$_ajax_max}',
	template:'{$_ajax_template}',
};
EOT;

		if ( ! is_singular() ) {

			$_scripts .= <<<EOT
(function($){
	$(document).ready(function(){
		$('#{$_parent_element}').saple({
			{$_output_mode}
			{$_more_string}
			{$_loading_symbol}
		});
	});
})(jQuery);
EOT;

		}

		echo preg_replace( '~\r\n|\r|\n|\t~', '', '<script type="text/javascript">' . $_scripts . '</script>' ) . "\n";

	}

	public function reregister_scripts( $_query_array = null, $_template_type = 'user1'  ) {

		global $SapleAdmin;

		$_option = $SapleAdmin->option();

		$_scripts = '';

		$_query_args = null;
		$_query      = null;

		$_query_args = $this->specify( $_query_array );
		$_query      = $this->query( $_query_args );

		$_parent_element = '' !== $_option['parent_element'] ? $_option['parent_element'] : 'main' ;
		$_output_mode    = 'scroll' !== $_option['output_mode'] ? 'scrolling: false,' : 'scrolling: true,';
		$_more_string    = '' !== $_option['more_string'] ? 'button: \'' . esc_html( $_option['more_string'] ) . '\',' : '';
		$_loading_symbol = '' !== $_option['loading_symbol'] ? preg_replace( '~\r\n|\r|\n|\t~', '', 'symbol: \'' . $_option['loading_symbol'] . '\',' ) : '';

		$_ajax_query    = json_encode( $_query_args );
		$_ajax_paged    = isset( $_query->query_vars['paged'] ) && 0 < $_query->query_vars['paged'] ? $_query->query_vars['paged'] : 1;
		$_ajax_max      = $_query->max_num_pages;
		$_ajax_template = $_template_type;

		$_scripts .= <<<EOT
saple_ajax.query = '{$_ajax_query}';
saple_ajax.paged = '{$_ajax_paged}';
saple_ajax.maxpages = '{$_ajax_max}';
saple_ajax.template = '{$_ajax_template}';
EOT;

		if ( is_singular() ) {

			$_scripts .= <<<EOT
(function($){
	$(document).ready(function(){
		$('#{$_parent_element}').saple({
			{$_output_mode}
			{$_more_string}
			{$_loading_symbol}
		});
	});
})(jQuery);
EOT;

		}

		echo preg_replace( '~\r\n|\r|\n|\t~', '', '<script type="text/javascript">' . $_scripts . '</script>' ) . "\n";

	}

	public function specify( $_query_array = null ) {

		if ( is_null( $_query_array ) ) {

			global $query_string;

			$_query_array = $query_string;

			if ( isset( $_GET['s'] ) ) {

				$_query_array = 'post_type=any&' . $_query_array;

				if ( '' === get_search_query() )
					$_query_array = 's=&' . $_query_array;

			}

			parse_str( $_query_array, $_query_array );

		} elseif ( ! is_array( $_query_array ) ) {

			parse_str( $_query_array, $_query_array );

		}

		return $_query_array;

	}

	private function query( $_query_args = null, $_paged = 0 ) {

		$_query = null;

		if ( is_array( $_query_args ) && 1 > count( $_query_args ) )
			$_query_args = array(
				'post_type' => 'post',
			);

		$_query_args['paged'] = $_paged;

		$_query = new WP_Query( $_query_args );

		if( isset( $_query_args['posts_per_page' ] ) )
			$_query->post_count = $_query_args['posts_per_page' ];

		return $_query;

	}

	public function template_type() {

		global $wp_query;

		$_template_type = '';

		$_post_type = isset( $wp_query->query['post_type'] ) ? $wp_query->query['post_type'] : '';

		if ( is_front_page() ) {

			$_template_type = 'frontpage';

		} elseif ( is_category() ) {

			$_template_type = 'category';

		} elseif ( is_tag() ) {

			$_template_type = 'tag';

		} elseif ( is_tax() ) {

			$_template_type = 'term';

		} elseif ( is_search() ) {

			$_template_type = 'search';

		} elseif ( is_date() ) {

			$_template_type = 'date';

		} elseif ( is_archive() && '' !== $_post_type && 'post' !== $_post_type && 'page' !== $_post_type && 'attachment' !== $_post_type && 'revision' !== $_post_type && 'nav_menu_item' !== $_post_type ) {

			$_template_type = 'cpost';

		} elseif ( is_archive() ) {

			$_template_type = 'archive';

		}

		return $_template_type;

	}

	public function template_path( $_template_type = '' ) {

		global $SapleAdmin;

		$_option = $SapleAdmin->option();

		$_template_path = '';

		switch ( $_template_type ){

			case 'frontpage':
				$_template_path = $_option['frontpage'];
				break;

			case 'category':
				$_template_path = $_option['category'];
				break;

			case 'tag':
				$_template_path = $_option['tag'];
				break;

			case 'term':
				$_template_path = $_option['term'];
				break;

			case 'search':
				$_template_path = $_option['search'];
				break;

			case 'date':
				$_template_path = $_option['date'];
				break;

			case 'cpost':
				$_template_path = $_option['cpost'];
				break;

			case 'archive':
				$_template_path = $_option['archive'];
				break;

		}

		for ( $i = 1; $i <= 10; $i++ ) {

			if ( 'user' . $i === $_template_type ) {

				$_template_path = $_option['user' . $i];

			}

		}

		if ( '' !== $_template_path && is_file( get_stylesheet_directory() . '/' . esc_html( $_template_path ) ) ) {

			$_template_path = get_stylesheet_directory() . '/' . esc_html( $_template_path );

		} elseif ( '' !== $_option['any'] && is_file( get_stylesheet_directory() . '/' . esc_html( $_option['any'] ) ) ) {

			$_template_path = get_stylesheet_directory() . '/' . esc_html( $_option['any'] );

		} else {

			$_template_path = dirname( __FILE__ ) . '/../views/content-default.php';

		}

		return $_template_path;

	}

	public function output() {

		$_query_args = null;
		$_paged      = 0;
		$_template   = '';

		$_template_path = '';

		$_query = null;

		$_query_args = isset( $_POST['saple_query'] ) && '' !== $_POST['saple_query'] ? json_decode( stripslashes( $_POST['saple_query'] ), true ) : array();
		$_paged      = isset( $_POST['saple_paged'] ) && '' !== $_POST['saple_paged'] ? intval( esc_html( $_POST['saple_paged'] ) ) : 0;
		$_template   = isset( $_POST['saple_template'] ) && '' !== $_POST['saple_template'] ? esc_html( $_POST['saple_template'] ) : '';

		$_template_path = $this->template_path( $_template );

		$_query = $this->query( $_query_args, $_paged );

		if ( $_query->have_posts() ) {

			while ( $_query->have_posts() ) {

				$_query->the_post();

				require( $_template_path );

			}

		}

		die();

	}

}
