(function($){
 
	$.fn.saple = function(options){
		var option = {
			symbol: '',
			scrolling: false,
			button: 'more',
		};
		var static = {
			control: 'saple-control',
			button: 'saple-button',
			buttonDisable: 'saple-button-disable',
			buttonNone: 'saple-button-none',
			loading: 'saple-loading',
			loadingDisable: 'saple-loading-disable',
			addPost: 'saple-add-post',
			addPostAfter: 'saple-add-post-after',
			countup: 1,
		};
		var config = $.extend(option, options);
		var inc = $(this);
 
		var saple = (function(){
			return{
				init: function(){
					if( parseInt(saple_ajax.paged, 10) < parseInt(saple_ajax.maxpages, 10) ){
						var symbol = '' == config.symbol ? '<div class="saple-spinner" />' : config.symbol
							scrolling = ! config.scrolling ? '' : static.buttonNone;

						inc
							.append('<div class="' + static.control + '" />')
							.children('.' + static.control)
								.append('<button class="' + static.button + '">' + config.button + '</button><div class="' + static.loading + ' ' +static.loadingDisable + '"></div>')
								.children('.' + static.loading).append(symbol);
						inc
							.children('.' + static.control)
								.children('.' + static.button).addClass(scrolling);

						this.clip();
					}
				},
				clip: function(){
					if( ! config.scrolling ){
						$('.' + static.button).bind('click', function(){
							saple.run($(this));
							return false;
						});
					}else{
						$(window).bind('load scroll', function(){
							if(typeof $('.' + static.control).eq(0).offset() !== 'undefined'){
								if($('.' + static.control).eq(0).offset().top <= $(window).scrollTop() + window.innerHeight){
									saple.run($('.' + static.button).eq(0));
								}
							}
						});
					}
				},
				run: function(button){
					if( ! button.hasClass(static.buttonDisable)){
						saple_ajax.paged = (parseInt(saple_ajax.paged, 10) + static.countup).toString(10);
						button
							.addClass(static.buttonDisable)
							.siblings('.' + static.loading).removeClass(static.loadingDisable);

						saple.posts(button);
					}
				},
				posts: function(button){
					$.ajax({
						type: 'POST',
						url: saple_ajax.url,
						data: {
							action: 'saple_output',
							saple_query: saple_ajax.query,
							saple_paged: saple_ajax.paged,
							saple_template: saple_ajax.template,
						},
						success: function(result){
							result = $(result).addClass(static.addPost);

							button.closest('.' + static.control).before(result);
							button.siblings('.' + static.loading).addClass(static.loadingDisable);

							if( parseInt(saple_ajax.paged, 10) >= parseInt(saple_ajax.maxpages, 10) ){
								button.siblings('.' + static.loading).remove();
								button.remove();
							}else{
								button.removeClass(static.buttonDisable);
							}
						},
						error: function(e) {
							//console.log(e);
						},
					});
				}
			};
		})();
 
		saple.init();
 
		return(this);
	};
 
})(jQuery);