<?php
/**
 * @package Slightly Ajax Posts Loader Engine
 * 
 * Copyright (C) 2018 CattleMute.
 *
 * View - Template Dashboard
 *
 */
 ?>

<div class="wrap wrap-saple">

	<h1><?php _e( 'Slightly Ajax Posts Loader Engine', 'saple' ); ?></h1>
	<p class="sentence"><?php _e( 'This plugin needs a little knowledge about the theme directory and HTML.', 'saple' ); ?></p>
	<p class="sentence"><?php _e( 'Addition loading with Ajax is done to posts.', 'saple' ); ?><br />
	<?php _e( 'Actions in reading can be set by button or scroll.', 'saple' ); ?></p>
	<p class="sentence"><?php _e( 'For each post to be read in additionally, we use the content template. (example: content.php, content-xxx.php)', 'saple' ); ?><br />
	<?php _e( 'Basically it can be used without directly editting the template of the theme, if it conforms to the template composition of WordPress official theme.', 'saple' ); ?><br />
	<?php _e( 'This plugin may not be suitable for themes with third-party or custom-made themes in which the HTML of each post is directly written in the main loop template.', 'saple' ); ?><br />
	<?php _e( 'Also, this plugin is not suitable for items with more than one posts type on 1 page.', 'saple' ); ?><br />
	</p>
	<p class="sentence"><?php _e( 'In addition, * you * must use CSS etc. to delete the pager and the pagenation to the theme.', 'saple' ); ?></p>

	<h2 class="heading"><?php _e( 'How to use', 'saple' ); ?></h2>
	<p class="sentence"><?php _e( 'First, Check the directory and the template file contents of your theme.', 'saple' ); ?><br />
		<?php _e( 'Based on the directory and the template file contents of the theme, if it is not set correctly, it will not work properly.', 'saple' ); ?></p>
	<p class="sentence"><?php _e( 'For example, when the theme has following the directory and the template file contents.', 'saple' ); ?></p>

	<h3 class="heading"><?php _e( 'Theme directory example', 'saple' ); ?> :</h3>
<pre class="source">
[-] your-using-theme-name
   [-] content
      [-] content.php
      [-] content-sub.php
   [-] archive.php
   [-] index.php
   [-] etc...
</pre>

	<h3 class="heading"><?php _e( 'Main loop template', 'saple' ); ?> :</h3>
<pre class="source">
&lt;?php
/**
 * Main Loop Template - archive.php
 */

get_header(); ?&gt;

&lt;div class="wrap"&gt;
	&lt;div id="primary"&gt;

		&lt;!--　<?php _e( 'Notice that it is the ID of the parent element of the part that reads the content template.', 'saple' ); ?>　--&gt;
		&lt;section id="main"&gt;
&lt;?php

	if ( have_posts() ) :
		while ( have_posts() ) : the_post();

			// <?php _e( 'This mean including the content template &quot;content/content-sub.php&quot;', 'saple' ); ?>

			get_template_part( 'content/content', 'sub' );

		endwhile;

	else :

		get_template_part( 'content/content', '404' );

	endif;
?&gt;
		&lt;/section&gt;

		&lt;section id="sub"&gt;
			&lt;?php get_sidebar(); ?&gt;
		&lt;/section&gt;
	&lt;/div&gt;
&lt;/div&gt;

&lt;?php get_footer(); ?&gt;
</pre>

	<h3 class="heading"><?php _e( 'Include content template on main loop', 'saple' ); ?> :</h3>
<pre class="source">
&lt;?php
/**
 * Content Template - content/content-sub.php
 */ ?&gt;

&lt;article id="post-&lt;?php the_ID(); ?&gt;" &lt;?php post_class(); ?&gt;&gt;
	&lt;header class="entry-header"&gt;
		&lt;p class="entry-date"&gt;&lt;?php the_date(); ?&gt;&lt;/p&gt;
		&lt;h1 class="entry-title"&gt;&lt;a href="&lt;?php the_permalink(); ?&gt;"&gt;&lt;?php the_title(); ?&gt;&lt;/a&gt;&lt;/h1&gt;
	&lt;/header&gt;
	&lt;div class="entry-content"&gt;
		&lt;?php the_excerpt(); ?&gt;
	&lt;/div&gt;
&lt;/article&gt;
</pre>

	<p class="sentence"><?php _e( 'The &quot;Posts load settings&quot; of the article list in this case is as follows.', 'saple' ); ?></p>

	<h3 class="heading"><?php _e( 'Posts load settings', 'saple' ); ?> :</h3>
	<table class="spec">
		<tr>
			<th><?php _e( 'Initial setting', 'saple' ); ?><br />&gt; <?php _e( 'Parent element ID', 'saple' ); ?></th>
			<td>main</td>
		</tr>
		<tr>
			<th><?php _e( 'Content template setting', 'saple' ); ?><br />&gt; <?php _e( 'Any content template', 'saple' ); ?></th>
			<td>content/content-sub.php</td>
		</tr>
	</table>

	<h2 class="heading"><?php _e( 'Posts load settings Details', 'saple' ); ?></h2>
	<p class="sentence"><?php _e( 'The following is a description of &quot;Posts load settings&quot;.', 'saple' ); ?></p>

	<h3 class="heading"><?php _e( 'Initial setting', 'saple' ); ?></h3>
	<table class="spec">
		<tr>
			<th><?php _e( 'Parent element ID', 'saple' ); ?></th>
			<td><?php _e( 'As parent with this element ID, append the controls and the load post content. A # of the selecter is not necessary.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Output mode', 'saple' ); ?></th>
			<td><?php _e( 'Select the output mode for load posts from Button or Scroll.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'More button caption', 'saple' ); ?></th>
			<td><?php _e( 'Enter the more button caption.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Loading symbol HTML', 'saple' ); ?></th>
			<td><?php _e( 'Enter HTML here if you want to specify the loading bar to display when loading posts.', 'saple' ); ?></td>
		</tr>
	</table>

	<h3 class="heading"><?php _e( 'Content template setting', 'saple' ); ?></h3>
	<p class="sentence"><?php _e( 'The directory path of the content template is specified as a relative path from the theme.', 'saple' ); ?></p>
	<table class="spec">
		<tr>
			<th><?php _e( 'Any content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for all archives. If you do not specify the content templates for archives such as categories and tags, the content template you set here will be displayed.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Frontpage content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for frontpage.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Category content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for category archive.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Tag content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for tag archive.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Term content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for term archive.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Custom post content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for custom post archive.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Search content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for custom search page.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Date content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set for date archive.', 'saple' ); ?></td>
		</tr>
		<tr>
			<th><?php _e( 'Other Archive content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies the content template to set when it is not match other archive above.', 'saple' ); ?></td>
		</tr>
	</table>

	<h3 class="heading"><?php _e( 'Content template extra setting', 'saple' ); ?></h3>
	<table class="spec">
		<tr>
			<th><?php _e( 'User defined content template', 'saple' ); ?></th>
			<td><?php _e( 'This specifies to set * your * made the content template. * You * can set 10 templates.', 'saple' ); ?></td>
		</tr>
	</table>

	<h2 class="heading"><?php _e( 'Setting for theme authors', 'saple' ); ?></h2>
	<p class="sentence"><?php _e( 'When looping the posts with WP_Query in the main loop template, specify &quot;option array to have in WP_Query&quot; and &quot;user defined content template&quot; on the template.', 'saple' ); ?><br /><?php _e( 'Add on the template so that you can display the list of articles in Ajax using the following function.', 'saple' ); ?></p>
	<table class="spec">
		<tr>
			<th><?php _e( 'saple_reregister_query_and_script( $_query_array, $_template_type );', 'saple' ); ?></th>
			<td><?php _e( 'Function', 'saple' ); ?></td>
			<td>
				<?php _e( 'Regenerate the script for acquiring posts by Ajax.', 'saple' ); ?><br /><br />
				<?php _e( '$_query_array is array to have in WP_Query.', 'saple' ); ?><br />
				<?php _e( '$_template_type is content template identify. Specify \'user1\' to \'user10\'. Also, you can use identifiers in &quot;Content template setting&quot;.', 'saple' ); ?>
			</td>
		</tr>
	</table>

	<h3 class="heading"><?php _e( 'For example installation', 'saple' ); ?> :</h3>
	<p class="sentence"><?php _e( 'In the example below, &quot;User defined content template1&quot; specified in &quot;Content template extra setting&quot; is included.', 'saple' ); ?></p>
<pre class="source">
&lt;?php
/**
 * Main Loop Template
 */

get_header(); ?&gt;

&lt;div class="wrap"&gt;
	&lt;div id="primary"&gt;

&lt;?php
	$args = array(
		'post_type' =&gt; 'topics',
	);

	<strong>saple_reregister_query_and_script( $args, 'user1' );</strong>

	$query = new WP_Query( $args );

?&gt;

		&lt;section id="main"&gt;
&lt;?php

	if ( $query->have_posts() ) :
		while ( $query->have_posts() ) : $query->the_post();

			get_template_part( 'content/content', 'userdefined' );

		endwhile;

	else :

		get_template_part( 'content/content', '404' );

	endif;
?&gt;
		&lt;/section&gt;

		&lt;section id="sub"&gt;
			&lt;?php get_sidebar(); ?&gt;
		&lt;/section&gt;
	&lt;/div&gt;
&lt;/div&gt;

&lt;?php get_footer(); ?&gt;
</pre>
	<table class="spec">
		<tr>
			<th><?php _e( 'Content template extra setting', 'saple' ); ?><br />&gt; <?php _e( 'User defined content template', 'saple' ); ?>1</th>
			<td>content/content-userdefined.php</td>
		</tr>
	</table>

	<small class="copyright"><?php _e( '' ) ?><small>

</div>