<?php
/**
 * @package Simplicity Add Fields Search Engine
 * 
 * Copyright (C) 2018 CattleMute.
 *
 * View - Template Setting
 *
 */
 ?>

<div class="wrap wrap-saple">
	<h1><?php _e( 'Posts load settings', 'saple' ); ?></h1>
	<form method="post" action="admin.php?page=saple_settings" class="form-saple">
		<h2><?php _e( 'Initial setting', 'saple' ); ?></h2>
		<table class="form-table form-saple-table">
			<tr>
				<th><?php _e( 'Parent element ID', 'saple' ); ?></th>
				<td>
					<?php $SapleAdmin->set_input( $_option_name . '[parent_element]', $_option['parent_element'] ); ?>
					<p class="caption"><?php _e( 'As parent with this element ID, append the controls and the load post content. A # of the selecter is not necessary.', 'saple' ); ?></p>
				</td>
			</tr>
			<tr>
				<th><?php _e( 'Output mode', 'saple' ); ?></th>
				<td>
					<?php $SapleAdmin->set_select( $_output_mode_array, $_option_name . '[output_mode]', $_option['output_mode'] ); ?>
					<p class="caption"><?php _e( 'Select the output mode for load posts from Button or Scroll.', 'saple' ); ?></p>
				</td>
			</tr>
			<tr>
				<th><?php _e( 'More button caption', 'saple' ); ?></th>
				<td>
					<?php $SapleAdmin->set_input( $_option_name . '[more_string]', $_option['more_string'] ); ?>
					<p class="caption"><?php _e( 'Enter the more button caption.', 'saple' ); ?></p>
				</td>
			</tr>
			<tr>
				<th><?php _e( 'Loading symbol HTML', 'saple' ); ?></th>
				<td>
					<?php $SapleAdmin->set_textarea( $_option_name . '[loading_symbol]', $_option['loading_symbol'] ); ?>
					<p class="caption"><?php _e( 'Enter HTML here if you want to specify the loading bar to display when loading posts.', 'saple' ); ?></p>
				</td>
			</tr>
		</table>

		<h2><?php _e( 'Content template setting', 'saple' ); ?></h2>
		<table class="form-table form-saple-table">
			<tr>
				<th><?php _e( 'Any content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[any]', $_option['any'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Frontpage content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[frontpage]', $_option['frontpage'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Category content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[category]', $_option['category'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Tag content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[tag]', $_option['tag'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Term content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[term]', $_option['term'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Custom post content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[cpost]', $_option['cpost'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Search content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[search]', $_option['search'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Date content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[date]', $_option['date'] ); ?></td>
			</tr>
			<tr>
				<th><?php _e( 'Other Archive content template', 'saple' ); ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[archive]', $_option['archive'] ); ?></td>
			</tr>
		</table>

		<h2><?php _e( 'Content template extra setting', 'saple' ); ?></h2>
		<table class="form-table form-saple-table">

<?php for ( $i = 1; $i <= 10; $i++ ) : ?>
			<tr>
				<th><?php _e( 'User defined content template', 'saple' ); ?><?php echo $i; ?></th>
				<td><?php $SapleAdmin->set_input( $_option_name . '[user' . $i . ']', $_option['user' . $i] ); ?></td>
			</tr>
<?php endfor; ?>

		</table>
		<p class="submit"><button class="button-primary"><?php esc_attr_e( 'Save' ); ?></button></p>
	</form>
</div>
